// Copyright  1989 Apple Computer, Inc. All rights reserved.


#ifndef __DriverWrapper__			// We do this so the header gets evaluated only once.
#define __DriverWrapper__

/**********************************Comment*****************************************
 * We declare these as extern "C" routines so we can have straight C (and in this 
 * case Pascal) calling conventions.  Notice the pointer to the 
 * parameter block (ParmBlkPtr) and the pointer to the Device Control Entry (DCtlPtr)
 * being passed in.  We've already set these up on the stack in DriverGlue.a.
 **********************************End Comment************************************/
#ifdef __cplusplus
extern "C" {							
#endif									
											

#include	<Types.h>
#include	<Devices.h>
#include	<Memory.h>
#include	<Files.h>

 	OSErr 	TSDRVROpen(ParmBlkPtr oParmBlock,DCtlPtr tsDCEPtr);
	OSErr		TSDRVRClose(ParmBlkPtr cParmBlock,DCtlPtr tsDCEPtr);
	OSErr		TSDRVRStatus(ParmBlkPtr sParmBlock,DCtlPtr tsDCEPtr);
	OSErr		TSDRVRPrime(ParmBlkPtr pParmBlock,DCtlPtr tsDCEPtr);
	OSErr		TSDRVRControl(ParmBlkPtr cntlParmBlock,DCtlPtr tsDCEPtr);
#ifdef __cplusplus
}
#endif

/**********************************Comment*****************************************
 *Finally, I have to define my own string copying routine because the stdio library
 * uses A5 and the global space.  I can't have that here, so I make my own little
 * utility routine.
 **********************************End Comment************************************/
 
char			*tseStrCpy(char *s, char *t);
#endif