/*
	IconWDEF.h
	
	Interface to Icon window definition class.
	
	by Patrick Beard.

	1990 by Patrick C. Beard.  All rights reserved.
 */

#ifndef __ICONWDEF__
#define __ICONWDEF__

#ifndef __WINDOWFRAME__
#include "WindowFrame.h"
#endif

class IconWindowDef : public WindowFrame {
public:
	// window methods.
	virtual void New(WindowPeek theWindow);
	virtual void CalcRgns();			// we have different regions when iconified.
	virtual void DrawFrame();			// we draw an icon if certain size.
	virtual long Hit(Point& whereHit);
private:
	Boolean iconified;					// state of our window.
	Boolean everIconified;				// if we've ever been iconified.
	Boolean requestingStateChange;		// we want to change our state.
	short calcRgnsCount;				// a counter.
	Rect iconifyRect;					// place to hit to iconify window.
	Point iconifiedLocation;			// where to put when iconified.
};

#endif
