/*
	Windoid.h
	
	Class that implements a "windoid" floating palette type window.
	
	Superclass:  WindowDefinition.
 */

#ifndef __WINDOID__
#define __WINDOID__


#ifndef __WINDOWDEFINITION__
#include "WindowDefinition.h"
#endif

class Windoid : public WindowDefinition {
public:
	// overridden methods.
	virtual void CalcRgns();							// compute all relevant regions.
	virtual void DrawFrame();							// draw the frame of the window.
	virtual void DrawGoAwayBox();						// draw the goaway box (toggle state).
	virtual void DrawGIcon();							// draw window's grow icon.
	virtual void DrawGrowImage(Rect& growRect);			// draw grow image of window.
	virtual long Hit(Point& whereHit);					// do hit testing.
private:
	void CalcRects();									// compute "hot" rectangles.
private:
	Rect itsFrame;
	Rect itsDragRect;
	Rect itsGoAwayBox;
};

#endif
