/*
	WindowFrame.h
	
	Interface to WindowFrame class.
	
	by Patrick Beard.
	
	1990 by Patrick C. Beard.  All rights reserved.
 */

#ifndef __WINDOWFRAME__
#define __WINDOWFRAME__

#include "WindowDefinition.h"

// macros.

#define topLeft(r)	(((Point*)&r)[0])
#define botRight(r)	(((Point*)&r)[1])

class WindowFrame : public WindowDefinition {
public:
	virtual void New(WindowPeek theWindow);
	virtual void Dispose();
	virtual void CalcRgns();
	virtual void DrawFrame();
	virtual void DrawGrowImage(Rect& growRect);
	virtual long Hit(Point& whereHit);
private:
	RgnHandle itsBorderRgn;		// border between content and structure boundaries.
};

#endif
